import org.example.Article;
import org.example.Main;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.serializer.JdkSerializationRedisSerializer;
import org.springframework.data.redis.serializer.StringRedisSerializer;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Set;

@SpringBootTest(classes = Main.class)
public class HashTest {
    @Autowired
    private RedisTemplate redisTemplate;

    @Test
    public void testPut(){
//        redisTemplate.setKeySerializer(new StringRedisSerializer());
//        redisTemplate.setHashKeySerializer(new StringRedisSerializer());
//        redisTemplate.setHashValueSerializer(new JdkSerializationRedisSerializer());
        Article article = new Article();
        article.setTitle("title");
        article.setCreateTime(new Date());
        article.setAuthor("lixiang");

        redisTemplate.opsForHash().put("article","1",article);
        System.out.println((Article) redisTemplate.opsForHash().get("article","1"));
    }

    @Test
    public void testGet(){
        redisTemplate.setKeySerializer(new StringRedisSerializer());
        redisTemplate.setHashKeySerializer(new StringRedisSerializer());
        redisTemplate.setHashValueSerializer(new JdkSerializationRedisSerializer());
        // 判断hashkey是否存在
        Boolean article = redisTemplate.opsForHash().hasKey("article", "2");
        System.out.println(article);

        //根据key和hashkey获取操作
        Article article1 = (Article) redisTemplate.opsForHash().get("article", "2");
        System.out.println(article1);


        //根据key获取所有的hashkey
        Set<String> set = redisTemplate.opsForHash().keys("article");
        for (Object s : set) {
            System.out.println(s);
        }


        List<Article> articles = redisTemplate.opsForHash().values("article");
        for (Article art : articles) {
            System.out.println(art);
        }

        Map<String,Article> map = redisTemplate.opsForHash().entries("article");
        for (Map.Entry<String, Article> entry : map.entrySet()) {
            System.out.println(entry.getKey()+":"+entry.getValue());
        }
    }

    //删除
    @Test
    public void testDelete(){
        //当hash中的数据全被删除后，整个hash就没了
        redisTemplate.opsForHash().delete("article","1","2");
    }
}
